# mypy-boto3-cloudhsmv2

[![PyPI - mypy-boto3-cloudhsmv2](https://img.shields.io/pypi/v/mypy-boto3-cloudhsmv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-cloudhsmv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-cloudhsmv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-cloudhsmv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.CloudHSMV2 1.14.18](https://boto3.amazonaws.com/v1/documentation/api/1.14.18/reference/services/cloudhsmv2.html#CloudHSMV2) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `CloudHSMV2` service.

```bash
python -m pip install boto3-stubs[cloudhsmv2]
```

## How to use

### Client annotations

`CloudHSMV2Client` provides annotations for `boto3.client("cloudhsmv2")`.

```python
import boto3

from mypy_boto3_cloudhsmv2 import CloudHSMV2Client
from mypy_boto3_cloudhsmv2.paginator import (
    DescribeBackupsPaginator,
    DescribeClustersPaginator,
    ListTagsPaginator,
)
from mypy_boto3_cloudhsmv2.type_defs import BackupTypeDef, ...

client: CloudHSMV2Client = boto3.client("cloudhsmv2")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CloudHSMV2Client = session.client("cloudhsmv2")
```

### Paginators annotations

`mypy_boto3_cloudhsmv2.paginator` module contains type annotations for all paginators.

```python

client: CloudHSMV2Client = boto3.client("cloudhsmv2")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_backups_paginator: DescribeBackupsPaginator = client.get_paginator("describe_backups")
describe_clusters_paginator: DescribeClustersPaginator = client.get_paginator("describe_clusters")
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
```







### Typed dictionations

`mypy_boto3_cloudhsmv2.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> BackupTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_cloudhsmv2` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("cloudhsmv2")

session_client = boto3.Session().client("cloudhsmv2")
```
